DOSSEG
.MODEL LARGE
 EXTRN	@aplikacia$qv :proc

.DATA
EXTRN	_active_key : WORD
text	db 'ASCII & COLOR TABLE (c) 1997'
	db 32,'Copyright Universal systems'
text1	db 'Press any key'
	db 32,'for return.'

.CODE
 public	_dos_install
 public _tabulka

; stary a novy PSP
_savepsp DW 0
_mypsp   DW 0

; stary a novy DTA
_intdta	 DD 0
_mydta	 DD 0

; pointer na disk_free promennu
df_es	 DW ?
df_bx	 DW ?

; povodna obsluha int 13h
_old_disk DD 0
; povodna obsluha int 16h
_old_vector DD 0
; povodna obsluha int 1bh
_old1b	  DD 0
; povodna obsluha int 28h
_old_28   DD 0

; residentne jadro aktivne?
_active	  DB 0
; int 13 aktivny
_diskflag DB 0
_rq	  DB 0

; promenna pro uschovani
; cisla BIOS-funkce
func	  DB ?

; stack preruseneho programu
ss_r	  DW ?
sp_r	  DW ?
; stack z instalacneho programu
ss_old	  DW ?
sp_old	  DW ?

r_x PROC  far
    pushf
    cmp	[_diskflag],0
    jne	near ptr y1
    call far ptr dos_free
    jne	near ptr y1
    call far ptr resident
    mov	[_rq],0
    jmp	near ptr y2
y1: mov	[_rq],1
y2: popf
    retf
r_x ENDP

; Nova obsluha int 16h
_intr_exec PROC FAR
	push ds
	pushf
	push bp
	mov bp,DGROUP
	mov ds,bp
	pop bp
	cmp [_active],0
	jne l2
	cmp ah,1
	jbe ie1
	cmp ah,10h
	je ie1
	cmp ah,11h
	je ie1
	cmp ax,0F300h
	jne l21
	mov ax,1234h
	jmp l24
l21:	cmp ax,0f400h
	jne l2
	call far ptr change
	je l23
l22:	mov ax,1
l24:	popf
	jmp l1
l23:	mov dx,word ptr [_old_vector]
	mov ds,word ptr [_old_vector+2]
	mov ax,2516h
	int 21h
	mov dx,word ptr [_old_disk]
	mov ds,word ptr [_old_disk+2]
	mov ax,2513h
	int 21h
	mov dx,word ptr [_old_28]
	mov ds,word ptr [_old_28+2]
	mov ax,2528h
	int 21h
	mov ax,[_mypsp]
	call far ptr deallocate
	popf
	xor ax,ax
	jmp l1
l2:	popf
	pushf
	call [_old_vector]
l1:	pop ds
	retf 2
ie1:	cmp [_rq],0
	je near ptr ie2
	call r_x
ie2:	mov [func],ah
	or  ah,ah
	jz ie3
	cmp  ah,10h
	jne  near ptr ie5
ie3:	sti
	pushf
	cli
	call [_old_vector]
	cmp  ax,[_active_key]
	je   ie4
	popf
	pop ds
	iret
ie4:	call r_x
l32:	mov  ah,[func]
	jmp ie3
ie5:	dec [func]
	pushf
	cli
	call [_old_vector]
	jz  ie6
	cmp ax,[_active_key]
	jne ie6
	mov ah,[func]
	pushf
	cli
	call [_old_vector]
	call r_x
ie6:	pop  ds
	pop  ds
	retf 2
_intr_exec ENDP

resident PROC FAR
    mov [_active],1
    cli
    mov [ss_r],ss
    mov [sp_r],sp
    mov ss,[ss_old]
    mov sp,[sp_old]
    sti
    push ax bx cx dx es ds si di
    push bp
    pushf
    mov ah,2fh
    mov word ptr [_intdta],bx
    mov word ptr [_intdta+2],es
    mov ah,1ah
    mov dx,word ptr [_mydta]
    mov ds,word ptr [_mydta+2]
    int 21h
    mov ah,51h
    int 21h
    mov [_savepsp],bx
    mov bx,[_mypsp]
    mov ah,50h
    int 21h
    mov ax,351bh
    int 21h
    mov word ptr [_old1b],bx
    mov word ptr [_old1b+2],es
    mov ax,251bh
    push cs
    pop ds
    mov dx,offset _ctrlbreak
    int 21h
    push bp
    mov bp,DGROUP
    mov ds,bp
    pop bp
    call @aplikacia$qv
    mov ax,251bh
    mov dx,word ptr [_old1b]
    mov ds,word ptr [_old1b+2]
    int 21h
    mov bx,[_savepsp]   ; obnov PSP
    mov ah,50h
    int 21h
    push ds
    mov ah,1ah
    mov dx,word ptr [_intdta]
    mov ds,word ptr [_intdta+2]
    int 21h
    pop ds
    popf
    pop bp
    pop di si ds es dx cx bx ax
    cli
    mov ss,[ss_r]
    mov sp,[sp_r]
    sti
    mov [_active],0
    retf
resident ENDP

deallocate  proc far
       push si di
       mov di,ax
       mov ah,52h
       int 21h
       mov si,word ptr es:[bx-2]
@4:    mov bx,si
       mov es,bx
       mov bx,1
       cmp word ptr es:[bx],di
       jne @5
       mov ah,49h
       inc si
       mov es,si
       dec si
       int 21h
@5:    xor ax,ax
       mov bx,si
       mov es,bx
       xor bx,bx
       cmp byte ptr es:[bx],'Z'
       je  @6
       mov bx,si
       mov es,bx
       mov bx,3
       mov ax,word ptr es:[bx]
       add ax,si
       inc ax
@6:    mov si,ax
       or ax,ax
       jne @4
       pop di si
       ret
deallocate endp

change	PROC	FAR
   push	cs
   pop dx
   mov ax,3516h
   int 21h
   mov ax,es
   cmp bx,offset _intr_exec
   jne c1
   cmp dx,ax
   jne c1
   mov ax,3513h
   int 21h
   mov ax,es
   cmp bx,offset _new_disk
   jne c1
   cmp dx,ax
   jne c1
   mov ax,3528h
   int 21h
   mov ax,es
   cmp bx,offset _new_28
   jne c1
   cmp dx,ax
c1: ret
change	ENDP

_ctrlbreak PROC FAR
	   iret
_ctrlbreak ENDP

_new_disk  PROC FAR
    mov	 [_diskflag],1
    pushf
    call [_old_disk]
    mov	 [_diskflag],0
    retf 2
_new_disk	ENDP

_new_28	PROC FAR
	pushf
	call [_old_28]
	pushf
	cmp [_active],0
	jne near ptr n1
	cmp [_rq],0
	je  near ptr n1
	cmp [_diskflag],0
	jne near ptr n1
	call far ptr resident
	mov [_rq],0
n1:	popf
	retf 2
_new_28	ENDP

dos_free PROC FAR
    push es bx
    mov	 es,[df_es]
    mov	 bx,[df_bx]
    cmp	 byte ptr es:[bx],0
    pop	 bx es
    ret
dos_free ENDP

_dos_install PROC FAR
     push si
     mov  si,ss
     mov  [ss_old],si
     mov  si,sp
     mov  [sp_old],si
     pop  si
     push ax es dx bx
     push ds
     push cs
     pop  ds
     mov  ax,3516h
     int  21h
     mov  word ptr [_old_vector],bx
     mov  word ptr [_old_vector+2],es
     mov  dx,offset _intr_exec
     mov  ax,2516h
     int  21h
     mov  ax,3513h
     int  21h
     mov  word ptr [_old_disk],bx
     mov  word ptr [_old_disk+2],es
     mov  dx,offset _new_disk
     mov  ax,2513h
     int  21h
     mov  ax,3528h
     int  21h
     mov  word ptr [_old_28],bx
     mov  word ptr [_old_28+2],es
     mov  dx,offset _new_28
     mov  ax,2528h
     int  21h
     pop  ds
     mov  ah,51h
     int  21h
     mov  [_mypsp],bx
     mov  ah,2fh
     int  21h
     mov  word ptr [_mydta],bx
     mov  word ptr [_mydta+2],es
     mov  ah,34h
     int  21h
     mov  [df_es],es
     mov  [df_bx],bx
     pop  bx dx es ax
     retf
_dos_install ENDP

vypis proc near
x10:  movsb
      stosb
      loop x10
      ret
vypis endp

transfer2 proc near
	push ax
	sub cx,cx
x0:     sub dx,dx
	div bx
	push dx
	inc cx
	test ax,ax
	jnz x0
	mov ax,word ptr[si+1]
	cmp ax,cx
	jbe x2
	mov bx,cx
	sub ax,cx
	mov cx,ax
	mov dl,48
x1:	mov es:[di],dl
	mov al,[si+0]
	mov es:[di+1],al
	inc di
	inc di
	loop x1
	mov cx,bx
x2:	pop dx
	or dl,'0'
	cmp dl,'9'
	jbe x3
	add dl,7
x3:	mov es:[di],dl
	mov al,[si+0]
	mov es:[di+1],al
	inc di
	inc di
	loop x2
	pop ax
	ret
color	db ?
null 	dw ?
transfer2 endp

poloha2 proc near
	mov dl,80
	mul dl
	add ax,bx
	mov dx,2
	mul dx
	ret
poloha2 endp

cls2 proc near
     xor di,di
     mov cx,80*25
     rep stosw
     ret
cls2 endp

uschovaj proc near
    push ds es
    mov ax,seg screen
    mov es,ax
    mov di,offset screen
    mov cx,80*25*2
    mov ax,0b800h
    mov ds,ax
    xor si,si
sk2: lodsb
    stosb
    loop sk2
    pop es ds
    ret
uschovaj endp

obnov proc near
     push ds es
     mov ax,0b800h
     mov es,ax
     xor di,di
     mov cx,80*25*2
     mov si,offset screen
     mov ax,seg screen
     mov ds,ax
sk3: lodsb
     stosb
     loop sk3
     pop es ds
     ret
obnov endp

screen db 4000 dup(0)

_tabulka proc far
	call uschovaj
	mov ax,0b800h
	mov es,ax
	mov ax,7*256+32
	call cls2
	mov ax,0 ;Riadok.
	mov bx,12 ;Stlpec.
	call poloha2
	mov di,ax
	mov si,offset text
	mov cx,56 ;Dlzka textu.
	mov al,7 ;Farba.
	call vypis
	mov ax,24 ;Riadok.
	mov bx,26 ;Stlpec.
	call poloha2
	mov di,ax
	mov si,offset text1
	mov cx,25 ;Dlzka textu.
	mov al,128+7 ;Farba.
	call vypis
	mov ax,2 ;Riadok.
	mov bx,4 ;Stlpec.
	call poloha2
	mov di,ax
	mov ax,3 ;Riadok.
	mov bx,4 ;Stlpec.
	xor dh,dh
	mov dl,0
	mov si,offset color
	mov cx,3 ;Zarovnanie
	mov [si+1],cx
	mov cx,256
x6:	push cx ax dx bx
	mov es:[di],dl
	inc di
	inc di
	mov al,'-'
	mov es:[di],al
	inc di
	inc di
	mov [si+0],dl
	mov al,dl
	mov bx,10 ;Sustava
	call transfer2
	mov cl,179
	mov es:[di],cl
	inc di
	inc di
	pop bx dx ax cx
	inc dl
	push ax dx
	call poloha2
	mov di,ax
	pop dx ax
	inc ax
	cmp ax,24
	jz posun
navrat:	loop x6
	jmp koniec
posun:	add bx,6
	mov ax,2
	jmp navrat
koniec: mov ax,0
	int 16h
	call obnov
	retf
_tabulka endp
	END

