; soubor OOPDEMO.ASM

IDEAL
MODEL SMALL, PASCAL

INCLUDE "OOPTBL.INC"
INCLUDE "OOPDEMO.ASO"

STACK

DATASEG
VideoPage DB ?
Xpos      DB 10
Ypos      DB 10
LineLength DW 20
WidthScreen DB 60

TBLINSTO Point
TBLINSTO Line

MyPoint  Point {}
MyLine   Line  {}

CODESEG
STARTUPCODE

         MOV AH,0Fh
         INT 10h
         MOV [Videopage],BH

         MOV CX,0000h
         MOV DX,184Fh
         MOV BH,7
         MOV AX,0700h
         INT 10h
;--------------------------
;Vypne zobrazovanie kurzora 
;v textovom rezime.
;--------------------------
           mov ah,01h
           mov cx,20h*256+00h
           int 10h
         
         MOV AX,@Data
         MOV ES,AX
         
         MOV DI,OFFSET MyPoint
         MOV AL,[Xpos]
	 MOV AH,[Ypos]  
         CALL Point PTR ES:DI METHOD init USES DS:BX PASCAL ,ES DI,AX
         CALL MoveObject PASCAL, ES DI

         MOV DI, OFFSET MyLine
         MOV AL,[Xpos]
         MOV AH,[Ypos]
         ;posledne cislo je velkost usecky
         CALL Line PTR ES:DI METHOD init USES DS:BX PASCAL ,ES DI,AX, [word LineLength]
         CALL MoveObject PASCAL, ES DI

;--------------------------
;Zapne zobrazovanie kurzora 
;v textovom rezime.
;--------------------------
          mov ah,01h
          mov cx,12h*256+14h
          int 10h
 
EXITCODE

PROC MoveObject
ARG  @@Object:DWORD
USES ES,DI,AX
         LES    DI,[@@Object]
         CALL Point PTR ES:DI METHOD show USES DS:BX PASCAL ,ES DI
@Loop:   MOV      AH,00h
         INT      16h
         CMP      AL,27
         JE       @Exit
         CMP      AH,78
         JE       @Zoomin 
         CMP      AH,74
         JE       @Zoomout 
         CMP      AL,00h
         JNZ      @Loop
         CMP      AH,72
         JNE      @@1
         CMP      [Ypos],0
         JE       @Loop
         DEC      [Ypos]
@@1:     CMP      AH,75 
         JNE      @@2
         CMP      [Xpos],0
         JE       @Loop
         DEC      [Xpos]
@@2:     CMP      AH,77  
         JNE      @@3
         PUSH AX
         MOV      AL,[WidthScreen]
         CMP      [Xpos],AL
         POP AX              ;pobvodne 79
         JE       @Loop
         INC      [Xpos]
@@3:     CMP      AH,80        
         JNE      @@4
         CMP      [Ypos],24
         JE       @Loop
         INC      [Ypos]
@@4:     CALL Point PTR ES:DI METHOD move USES DS:BX PASCAL ,ES DI, [WORD Xpos]
         JMP @Loop


@Zoomout: JMP @Zoomout2

@Exit:   CALL Point PTR ES:DI METHOD hide USES DS:BX PASCAL ,ES DI
         JMP @Exit2

@Zoomin: PUSH CX
         MOV   CX, [word LineLength]
         INC CX
         MOV   [word LineLength],CX
         MOV      CL,[WidthScreen]
         DEC      CL
         MOV      [WidthScreen],CL
         POP CX        
         CALL Line PTR ES:DI METHOD init USES DS:BX PASCAL ,ES DI,AX, [word LineLength]
         CALL Point PTR ES:DI METHOD move USES DS:BX PASCAL ,ES DI, [WORD Xpos]
         JMP @Loop

@Zoomout2: PUSH CX
           MOV   CX, [word LineLength]
           DEC CX
           MOV   [word LineLength],CX
           MOV      CL,[WidthScreen]
           INC      CL
           MOV      [WidthScreen],CL
           POP CX 
           CALL Point PTR ES:DI METHOD hide USES DS:BX PASCAL ,ES DI
           CALL Line PTR ES:DI METHOD init USES DS:BX PASCAL ,ES DI,AX, [WORD LineLength]
           CALL Point PTR ES:DI METHOD move USES DS:BX PASCAL ,ES DI, [WORD Xpos]
           JMP @Loop

@Exit2:  RET
ENDP

;========================================================;
; Procedury metod objektu Point                          ;
;========================================================;
  
PROC Point_init
ARG @@Point:DWORD, @@InitXY:WORD
USES DS,BX,AX
   
   LDS      BX, [@@Point]
   TBLINITO Point, DS:BX
   MOV      AX, [@@InitXY]
   MOV      [(Point PTR DS:BX).XY], AX
   RET
ENDP

PROC Point_show
ARG @@Point:DWORD
USES DS,ES,BX,DX,CX,AX,SI,DI

   LDS BX, [@@Point]
   
   MOV DX, [(Point PTR DS:BX).XY]
   MOV BH,[VideoPage]
   mov ah,02h
   INT 10h

   MOV CX,1
   MOV AL,254 ;znak nahradzujuci bod
   MOV AH,0Ah
   INT 10h

   RET
ENDP

PROC Point_hide
ARG @@Point:DWORD
USES DS,ES,BX,DX,CX,AX,SI,DI

   LDS BX, [@@Point]

   MOV DX, [(Point PTR DS:BX).XY]
   MOV BH, [VideoPage]
   MOV AH,02h
   INT 10h

   MOV CX,1
   MOV AL,' '
   MOV AH,0Ah
   INT 10h

   RET
ENDP

PROC Point_move
ARG @@Point:DWORD,@@NewXY:WORD
USES DS,ES,BX,DI,AX
   LDS BX, [@@Point]
   CALL Point PTR DS:BX METHOD Hide USES ES:DI PASCAL ,DS,BX
   MOV AX, [@@NewXY]
   MOV [(Point PTR DS:BX).XY], AX
   CALL Point PTR DS:BX METHOD Show USES ES:DI PASCAL ,DS,BX
   RET
ENDP 

PROC Point_GetXY
ARG @@Point:DWORD
USES DS,BX
   
   LDS BX, [@@Point]
   MOV AX, [(Point PTR DS:BX).XY]
   RET
ENDP

;====================================================;
; Procedury metod objektu Line                       ;
;====================================================;

PROC Line_init
ARG @@Point:DWORD, @@InitXY:WORD, @@Length:WORD
USES DS,BX,AX

   LDS      BX, [@@Point]
   TBLINITO Line, DS:BX
   MOV      AX, [@@InitXY]
   MOV      [(Line PTR DS:BX).XY], AX
   MOV      AX, [@@Length]
   MOV      [(Line PTR DS:BX).Length], AX
   RET 
ENDP

PROC Line_show
ARG @@Line:DWORD
USES DS,ES,BX,DX,CX,AX,SI,DI

   LDS BX, [@@Line]
   PUSH BX
   MOV DX, [(Line PTR DS:BX).XY]
   MOV BH,[VideoPage]
   MOV AH,02h
   INT 10h

   POP BX 
   MOV CX, [(Line PTR DS:BX).Length]
   MOV AL, 196
   MOV AH,0Ah
   INT 10h

   RET
ENDP

PROC Line_hide
ARG @@Line:DWORD
USES DS,ES,BX,DX,CX,AX,SI,DI

   LDS BX, [@@Line]
   PUSH BX
   MOV DX, [(Line PTR DS:BX).XY]
   MOV BH,[VideoPage]
   MOV AH,02h

   INT 10h
   POP BX 
   MOV CX, [(Line PTR DS:BX).Length]
   mov AL,' '
   MOV AH,0Ah
   INT 10h

   RET
ENDP

PROC Line_getlen
ARG @@Point:DWORD
USES DS,BX

   LDS BX, [@@Point]
   MOV AX, [(Point PTR DS:BX).XY]
   RET
ENDP

END 











 
         
