.model small
.stack 100h
.data

cislo db 0,0
text1 db "Stlac klaves! $"
text2 db "Stlaceny klaves ma Scan kod: $"
text3 db "Press any key for return to DOS."
text4 db "ASCII kod: $"

.code
;--------------------------
;Vypne zobrazovanie kurzora 
;v textovom rezime.
;--------------------------
kurzor_off proc near
           mov ah,01h             
           mov cx,20h*256+00h
           int 10h
           ret
kurzor_off endp

;--------------------------
;Zapne zobrazovanie kurzora 
;v textovom rezime.
;--------------------------
kurzor_on proc near
          mov ah,01h             
          mov cx,12h*256+14h
          int 10h
          ret
kurzor_on endp


position  proc  near
          mov   bh,0
          mov   ah,02
          int   10h
          ret
position  endp

transfer proc near
       push    ax
       xor     cx, cx
wn0:   xor     dx, dx
       div     bx
       push    dx
       inc     cx
       test    ax, ax
       jnz     wn0
wn2:   pop     dx
       or      dl, '0'
       cmp     dl, '9'
       jbe     wn3
       add     dl, 7
wn3:   mov     ah, 2
       int     21h
       loop    wn2
       pop    ax
       ret
transfer endp

print proc near
cykl: movsb
      stosb
      loop cykl
      ret
print endp

address proc near
        mov dl,80
        mul dl
        add ax,bx
        mov dx,2
        mul dx  
        ret
address endp

start:  mov ax,@data
        mov ds,ax
        mov ax,0b800h
        mov es,ax
        mov ax,3
        int 10h
        call kurzor_off
        mov dx,10*256+17
        call position

        lea   dx,text1
        mov   ah,09h
        int   21h
        mov ax,11h
        int 16h
        push ax
        mov dx,12*256+10
        call position

        lea   dx,text2
        mov   ah,09h
        int   21h
        pop ax

        mov si,offset cislo
        mov [si+0],ax   
        mov al,[si+1]    
        xor ah,ah
        mov bx,10
        call transfer
        mov dx,14*256+28
        call position
        lea dx,text4
        mov ah,9
        int 21h
        mov al,[si+0]    
        xor ah,ah
        mov bx,10
        call transfer

        mov ax,16   ;Riadok.
        mov bx,10   ;Stlpec
        call address
        mov di,ax
        mov si,offset text3
        mov cx,32 ;Dlzka textu
        mov al,7+128;Farba
        call print
        call kurzor_off

        mov ax,0
        int 16h

        call kurzor_on          
        mov ax,4c00h
        int 21h
        end start


