.model small
.stack 100h
.data

txt1 db '###############',10,13
     db '# (o) Black   #',10,13
     db '# ( ) Blue    #',10,13
     db '# ( ) Green   #',10,13
     db '# ( ) Red     #',10,13
     db '# ( ) Magenta #',10,13
     db '# ( ) Brown   #',10,13
     db '# ( ) Exit    #',10,13
     db '###############',10,13,'$'

txt2 db 'Do you wish to quit program? NO/YES$'
txt3 db 'Unable to detect mouse driver.$'

r_cx  dw 0
r_dx  dw 0

screen db 4000 dup(?)

.code
position  proc  near
          mov   bh,0
          mov   ah,02
          int   10h
          ret
position  endp

;Vypocet adresy vo videoram.
;---------------------------------
;Vstup: AX=riadok, BX=stlpec.
;Vystup: AX obsahuje offset adresy.
;---------------------------------
;Vzorec: [(80*AX)+BX]*2
;---------------------------------
poloha2 proc near
        mov dl,80
        mul dl
        add ax,bx
        mov dx,2
        mul dx
        ret
poloha2 endp

;--------------------------
;Vypne zobrazovanie kurzora 
;v textovom rezime.
;--------------------------
kurzor_off proc near
           mov ah,01h             
           mov cx,20h*256+00h
           int 10h
           ret
kurzor_off endp

;--------------------------
;Zapne zobrazovanie kurzora 
;v textovom rezime.
;--------------------------
kurzor_on proc near
          mov ah,01h             
          mov cx,12h*256+14h
          int 10h
          ret
kurzor_on endp

cls proc near
       xor di,di
       inc di
       mov cx,80*25
skok1: stosb
       inc di
       loop skok1
       ret
cls endp

uschovaj proc near
       push ds
       push es
       mov ax,seg screen
       mov es,ax
       mov di,offset screen
       mov cx,80*25*2
       mov ax,0b800h
       mov ds,ax
       xor si,si
skok2: lodsb
       stosb
       loop skok2
        pop es
        pop ds        
        ret
uschovaj endp

obnov proc near
       push ds
       push es
       mov ax,0b800h
       mov es,ax
       xor di,di
       mov cx,80*25*2
       mov si,offset screen
       mov ax,seg screen
       mov ds,ax
skok3: lodsb
       stosb
       loop skok3
        pop es
        pop ds        
        ret
obnov endp
      
cls2 proc near
      mov al,32
      mov cx,7
      mov di,166
      cld 
skok: stosb
      dec di
      add di,160 
      loop skok
      ret
cls2 endp
              
start:  mov ax,@data
        mov ds,ax
        mov ax,0b800h
        mov es,ax
        mov ax,3
        int 10h
        xor ax,ax
        int 33h
        cmp ax,0
         jnz pokracuj
         lea dx,txt3
         mov ah,9
         int 21h
         mov ax,4c00h
         int 21h
pokracuj: call kurzor_off
         lea dx,txt1
        mov ah,9
        int 21h
        mov al,7
        call cls
        mov ax,1
        int 33h 
lop:    mov ax,03
        int 33h
        and bl,00000001b
        jnz testx
        jmp short lop
testx:   mov [r_cx],cx
         mov [r_dx],dx
         mov ax,[r_dx]
         xor dx,dx
         mov bl,8
         div bl
         mov [r_dx],ax
         mov ax,[r_cx]
         xor dx,dx
         mov bl,8
         div bl
         mov [r_cx],ax
         cmp [r_dx],1
         jnz xxx
         cmp [r_cx],3
         mov al,7
         jz vykonaj
xxx:     cmp [r_dx],2
         jnz xxx1
         cmp [r_cx],3
         mov al,31
         jz vykonaj  
xxx1:    cmp [r_dx],3
         jnz xxx2
         cmp [r_cx],3
         mov al,47
         jz vykonaj  
xxx2:     cmp [r_dx],4
         jnz xxx3
         cmp [r_cx],3
         mov al,79
         jz vykonaj  
xxx3:     cmp [r_dx],5
         jnz xxx4
         cmp [r_cx],3
         mov al,95
         jz vykonaj  
xxx4:     cmp [r_dx],6
         jnz xxx5
         cmp [r_cx],3
         mov al,111
         jz vykonaj  
xxx5:    cmp [r_dx],7
         jnz xxx6
         cmp [r_cx],3
         jz exit  
xxx6:    jmp lop
vykonaj: push ax 
         mov ax,2
         int 33h 
         pop ax
         call cls
         call cls2
         mov ax,[r_dx]
         mov bx,[r_cx]
         call poloha2
         mov di,ax
         mov al,'o'
         mov [es:di],al
         call uschovaj
         mov ax,1
         int 33h 
         jmp lop
exit:    call cls2
         mov ax,2
         int 33h 
         mov al,"o"
         mov [es:1126],al
         mov dx,4*256+25
         call position
         lea dx,txt2
         mov ah,9
         int 21h
         mov ax,1
         int 33h 

lop1:    mov ax,03
        int 33h
        and bl,00000001b
        jnz testx1
        jmp short lop1
testx1:  mov [r_cx],cx
         mov [r_dx],dx
         mov ax,[r_dx]
         xor dx,dx
         mov bl,8
         div bl
         mov [r_dx],ax
         mov ax,[r_cx]
         xor dx,dx
         mov bl,8
         div bl
         mov [r_cx],ax
         cmp [r_cx],54
         jnz xx
         cmp [r_dx],4
         jz xx5
xx:      cmp [r_cx],55
         jnz xx1
         cmp [r_dx],4
         jz xx5  
xx1:     cmp [r_cx],57
         jnz xx2
         cmp [r_dx],4
         jz vykonaj1
xx2:     cmp [r_cx],58
         jnz xx3
         cmp [r_dx],4
         jz vykonaj1
xx3:     cmp [r_cx],59
         jnz xx4
         cmp [r_dx],4
         jz vykonaj1  
xx4:     jmp short lop1
xx5:     mov ax,2
         int 33h 
         call obnov
         mov ax,1
         int 33h 
         jmp lop
vykonaj1: call kurzor_on
         mov ax,3
         int 10h 
         mov ax,4c00h
         int 21h
         end start
